'use strict';
var loginController = angular.module('NotibeProject.controllers.authentication', []);

loginController.controller('AuthenticationController',
        ['$rootScope', '$scope', '$state', 'Session', 'Authentication', 'Popup', 'I18n', 'Analytics',
            function ($rootScope, $scope, $state, Session, Authentication, Popup, I18n, Analytics) {

                Analytics.trackView("Authentication");

                $scope.isIos = function () {
                    return Session.isIos();
                };

                $scope.isLocalized = function () {
                    return I18n.isLocalized();
                };

                $scope.getText = function (key) {
                    return I18n.getText(key);
                };

                $scope.goBack = function () {
                    $state.go('begin');
                };

                $scope.goLogin = function () {
                    $state.go("login", {}, {});
                };

                $scope.goRecover = function () {
                    $state.go("recover", {}, {});
                };

                // Form data
                $scope.loginData = {};
                $scope.signupData = {};
                $scope.recoverData = {};
                $scope.userData = {};

                // Perform the signup
                $scope.doSignup = function () {
                    var signupData = $scope.signupData;
                    if (signupData.firstname === undefined
                            || signupData.lastname === undefined
                            || signupData.email === undefined
                            || signupData.password === undefined) {
                        Popup.message("Notibe", "compile_fields");
                    } else {
                        Authentication.signup(signupData, function () {
                            //reload stream
                            try {
                                $rootScope.refreshStream();
                            } catch (error) {

                            }
                            $state.go("menu.stream", {}, {});
                        });
                    }
                };

                // Perform the login action when the user submits the login form
                $scope.doLogin = function () {
                    var loginData = $scope.loginData;
                    if (loginData.email === undefined
                            || loginData.password === undefined) {
                        Popup.message("Notibe", "compile_fields");
                    } else {
                        Authentication.login(loginData,
                                function () {
                                    //reload stream
                                    try {
                                        $rootScope.refreshStream();
                                    } catch (error) {

                                    }
                                    $state.go("menu.stream", {}, {});
                                },
                                function () {
                                    $state.go("begin", {}, {location: "replace"});
                                });
                    }
                };

                $scope.recoverRequestForm = function () {
                    $state.go("recover_request", {}, {location: "replace"});
                };

                $scope.doRecoveryRequest = function () {
                    Authentication.requestRecovery($scope.recoverData.email,
                            function () {
                                Popup.message("recover_requested", "wait_code");
                                $state.go("recover_confirm", {}, {location: "replace"});
                            },
                            function () {
                                Popup.error("recover_request_error");
                            });
                };

                $scope.recoverConfirmForm = function () {
                    $state.go("recover_confirm", {}, {location: "replace"});
                };

                $scope.doRecoveryConfirm = function () {
                    Authentication.confirmRecovery($scope.recoverData.email, $scope.recoverData.checkcode, $scope.recoverData.newpassword,
                            function () {
                                Popup.message("recover_confirmed", "password_changed");
                                $state.go("login", {}, {location: "replace"});
                            },
                            function () {
                                Popup.error("recover_confirm_error");
                            });
                };

            }]);
