'use strict';
var beginController = angular.module('NotibeProject.controllers.begin', []);

beginController.controller('BeginController',
        ['$scope', '$state', 'I18n', 'Session', 'Facebook', 'Analytics',
            function ($scope, $state, I18n, Session, Facebook, Analytics) {

                Analytics.trackView("Begin");

                $scope.isLocalized = function () {
                    return I18n.isLocalized();
                };

                $scope.getText = function (key) {
                    return I18n.getText(key);
                };

                $scope.loginForm = function () {
                    Session.loginType = 'app';
                    $state.go("login", {}, {location: "replace"});
                };

                $scope.notify = function () {
                    $state.go('menu.notify');
                };

                $scope.loginWithFacebook = function () {
                    Session.loginType = 'facebook';
                    Facebook.login(
                            function () {
                                console.log("logged with facebook");
                                //reload stream
                                try {
                                    $rootScope.refreshStream();
                                } catch (error) {

                                }
                                $state.go("menu.stream", {}, {location: "replace"});
                            },
                            function () {
                                console.log("error login with facebook");
                                $state.go("begin", {}, {location: "replace"});
                            });
                };

                $scope.signupForm = function () {
                    $state.go("signup", {}, {location: "replace"});
                };
            }]);
