'use strict';
var cdcgridController = angular.module('NotibeProject.controllers.cdcgrid', ['ionic']);

cdcgridController.controller('CdcGridController',
        ['$rootScope', '$scope', '$state', 'I18n', 'Analytics', 'Session', 'Subscription', '$ionicScrollDelegate',
            function ($rootScope, $scope, $state, I18n, Analytics, Session, Subscription, $ionicScrollDelegate) {

                Analytics.trackView("CdcGrid");

                $scope.isLocalized = function () {
                    return I18n.isLocalized();
                };

                $scope.getText = function (key) {
                    return I18n.getText(key);
                };

                $scope.viewStream = function () {
                    //clean before going back
                    Session.sessionData.contentCreators.search = null;
                    Session.sessionData.contentCreators.page = -1;
                    Session.sessionData.contentCreators.has_next = true;
                    Session.sessionData.contentCreators.list = [];
                    try {
                        console.log("triggered stream refresh");
                        $rootScope.refreshStream();
                    } catch (error) {

                    }
                    $state.go("menu.stream");
                };

                $scope.cdcRows = Session.sessionData.contentCreators.list;

                $scope.usersSubscriptions = Session.currentUser.subscriptionsDictionary;

                $scope.subscribe = function (cdc, row, col) {
                    Subscription.subscribeContentCreator(cdc, function () {
                        //manage matrix
                        $scope.cdcRows[row][col].subscribed = true;
                        var addButton = document.getElementById("add_" + row + "_" + col);
                        angular.element(addButton).addClass("ng-hide");
                        angular.element(addButton).removeClass("ng-show");
                        var remButton = document.getElementById("rem_" + row + "_" + col);
                        angular.element(remButton).addClass("ng-show");
                        angular.element(remButton).removeClass("ng-hide");
                    });
                };

                $scope.unsubscribe = function (cdc, row, col) {
                    Subscription.unsubscribeContentCreator(cdc, function () {
                        //manage matrix
                        $scope.cdcRows[row][col].subscribed = false;
                        var addButton = document.getElementById("add_" + row + "_" + col);
                        angular.element(addButton).addClass("ng-show");
                        angular.element(addButton).removeClass("ng-hide");
                        var remButton = document.getElementById("rem_" + row + "_" + col);
                        angular.element(remButton).addClass("ng-hide");
                        angular.element(remButton).removeClass("ng-show");
                    });
                };

                $scope.searchString = {value: ""};

                $scope.canDoSearch = true;

                $scope.searchContentCreator = function () {
                    if ($scope.canDoSearch) {
                        $scope.canDoSearch = false;
                        console.log("Search string: " + $scope.searchString.value);
                        //clean before searching cdc
                        Session.sessionData.contentCreators.search = $scope.searchString.value;
                        Session.sessionData.contentCreators.page = -1;
                        Session.sessionData.contentCreators.has_next = true;
                        Session.sessionData.contentCreators.list = [];
                        console.log("called search cdc for: " + Session.sessionData.contentCreators.search);
                        //search
                        if (Session.sessionData.contentCreators.has_next) {
                            Subscription.getContentCreators((Session.sessionData.contentCreators.page + 1), function () {
                                $scope.cdcRows = Session.sessionData.contentCreators.list;
                                ionic.DomUtil.blurAll();
                                $scope.canDoSearch = true;
                            });
                        }
                    }
                };

                $scope.loadMore = function () {
                    //reload stream
                    if (Session.sessionData.contentCreators.has_next) {
                        Subscription.getContentCreators((Session.sessionData.contentCreators.page + 1), function () {
                            $scope.cdcRows = Session.sessionData.contentCreators.list;
                            $ionicScrollDelegate.resize();
                        });
                    }
                };

                $scope.areThereMore = function () {
                    return Session.sessionData.contentCreators.has_next;
                };
            }]);
