'use strict';

var analyticsService = angular.module('NotibeProject.services.analytics', []);

analyticsService.factory('Analytics', [function () {
        var monitorId = 'UA-56631451-1';
        return {
            init: function () {
                try {
                    analytics.startTrackerWithId(monitorId);
                } catch (error) {
                    console.log("NOTIBE: Error in starting analytics.");
                }
            },
            trackView: function (view) {
                try {
                    analytics.trackView(view);
                } catch (error) {
                    console.log("NOTIBE: Error in trackin view.");
                }
            },
            trackAction: function (view, action) {
                try {
                    analytics.trackEvent(view, action);
                } catch (error) {
                    console.log("NOTIBE: Error in trackin view and action.");
                }
            },
            setUser: function (userId) {
                try {
                    analytics.setUserId(userId);
                } catch (error) {
                    console.log("NOTIBE: Error in setting userid.");
                }
            }
        };
    }]);