'use strict';

var facebookService = angular.module('NotibeProject.services.facebook', []);

facebookService.factory('Facebook', ['Authentication', 'Analytics', function (Authentication, Analytics) {
        var permissions = ["public_profile"];
        return {
            login: function (successHandler, failureHandler) {
                try {
                    facebookConnectPlugin.login(permissions,
                            function (result) {
                                //if login has success get the status
                                facebookConnectPlugin.getAccessToken(
                                        function (token) {
                                            //pass the token to the server
                                            Authentication.loginFacebook(token,
                                                    function () {
                                                        console.log("notibe login with facebook: ok");
                                                        //success
                                                        successHandler();
                                                    },
                                                    function () {
                                                        //failure
                                                        failureHandler();
                                                    }
                                            );
                                        },
                                        function (error) {
                                            //error
                                            console.log("error with facebookConnectPlugin.getAccessToken()" + error);
                                            Analytics.trackAction("Error", "facebookConnectPlugin:getAccessToken()");
                                        }
                                );
                            },
                            function (error) {
                                //error
                                console.log("error with facebookConnectPlugin.login(): " + error);
                                Analytics.trackAction("Error", "facebookConnectPlugin:login()");
                            }
                    );
                } catch (error) {
                    //error
                    console.log("Cannot load facebookConnectPlugin");
                }
            },
            logout: function (successHandler) {
                facebookConnectPlugin.logout(
                        function () {
                            console.log("facebookConnectPlugin.logout(): ok");
                            successHandler();
                        },
                        function () {
                            //nope
                            console.log("error with facebookConnectPlugin.logout()");
                            Analytics.trackAction("Error", "facebookConnectPlugin:logout()");
                        });
            }
        };
    }]);