'use strict';

var i18nService = angular.module('NotibeProject.services.i18n', []);

i18nService.factory('I18n', ['$filter', function ($filter) {
        var localizedText = {
            "it": {
                "signin": "ACCESSO",
                "login": "Accedi con Notibe",
                "loginFacebook": "Accedi con Facebook",
                "logout": "Esci",
                "signup": "REGISTRATI",
                "password": "password",
                "firstname": "nome",
                "lastname": "cognome",
                "email": "email",
                "forgot": "recupera password",
                "forgot_choice": "CAMBIO PASSWORD",
                "forgot_confirm": "INVIA PASSWORD",
                "forgot_request": "RICHIEDI CODICE",
                "signin_upper": "ACCEDI",
                "signin_button": "Accedi",
                "register": "Registra",
                "recover": "Invia richiesta",
                "logged": "Connesso come",
                "newentries": "Attività recenti",
                "laston": "ultima notifica",
                "channelist": "Lista Canali",
                "config": "Configurazioni",
                "subscriptions": "Iscrizioni",
                "managesub": "Tocca il bottone rosso per rimuovere il canale. Disattiva lo switch per ricevere solo le notifiche urgenti.",
                "logout_title": "Sicuro di voler uscire?",
                "logout_message": "Questa operazione chiuderà l'applicazione.",
                "logout_message_ios": "Dovrai rieffettuare la login.",
                "terms": "Termini di utilizzo",
                "compile_fields": "Compila tutti i campi!",
                "user_not_found": "Utente non trovato.",
                "wrong_password": "Password sbagliata.",
                "token_expired": "Sessione scaduta. Esegui un nuovo accesso per favore.",
                "user_invalid": "Utente non valido.",
                "user_exists": "Esiste già un utente per l'email fornita.",
                "user_not_created": "Non è stato possibile creare l'utente.",
                "app_to_update": "Nuova applicazione uscita! Aggiornare?",
                "app_no_service": "Servizio non disponibile, riprova più tardi. Ci scusiamo per il disagio.",
                "error": "Errore",
                "debug": "Debug",
                "toast_open": "Avvio...",
                "toast_open_fb": "Avvio Facebook...",
                "toast_open_yt": "Avvio Youtube...",
                "toast_open_g+": "Avvio Google+...",
                "toast_open_br": "Avvio Browser...",
                "toast_copy": "Link copiato negli appunti!",
                "toast_unsubscribed": "Iscrizione eliminata!",
                "toast_np_enabled": "Notifiche normali: Abilitate.",
                "toast_np_disabled": "Notifiche normali: Disabilitate.",
                "share_from_clipboard": "Incolla testo dagli appunti!",
                "share_mail_from": "Notifica da",
                "share_mail_notify": "Notifica",
                "scroll_cdc": "Scorri lista per vedere tutti i creatori di contenuti",
                "previous_notifications": "Notifiche precedenti",
                "load_more": "Carica altro...",
                "search_cdc": "Cerca...",
                "recover_request": "Richiedi recupero",
                "recover_confirm": "Conferma recupero",
                "checkcode": "codice di controllo",
                "newpassword": "nuova password",
                "confirm_password": "Invia password",
                "recover_requested": "Recupero richiesto",
                "wait_code": "Attendi la mail con il codice per il cambio password.",
                "recover_request_error": "Errore nell'invio della richiesta. Contatta il team.",
                "recover_confirmed": "Recupero eseguito",
                "password_changed": "La password è stata cambiata correttamente.",
                "recover_confirm_error": "Errore nel cambio della password. Contatta il team."
            },
            "en": {
                "signin": "SIGNIN",
                "login": "Login with Notibe",
                "loginFacebook": "Login with Facebook",
                "logout": "Logout",
                "signup": "NEW ACCOUNT",
                "password": "password",
                "firstname": "firstname",
                "lastname": "lastname",
                "email": "email",
                "forgot": "recover password",
                "forgot_choice": "CHANGE PASSWORD",
                "forgot_confirm": "SEND PASSWORD",
                "forgot_request": "REQUEST CODE",
                "signin_upper": "LOGIN",
                "signin_button": "Login",
                "register": "Register",
                "recover": "Send request",
                "logged": "Logged as",
                "newentries": "Recent activities",
                "laston": "last on",
                "channelist": "Channel List",
                "config": "Config",
                "subscriptions": "Subscriptions",
                "managesub": "Remove channels or manage notifications priority, turn off to receive only important notifications.",
                "logout_title": "Are you sure to logout?",
                "logout_message": "This operation will close application.",
                "logout_message_ios": "You'll have to login again.",
                "terms": "Terms of use",
                "compile_fields": "Compile every input field!",
                "user_not_found": "User not found.",
                "wrong_password": "Wrong password.",
                "token_expired": "Expired session. Please log in again.",
                "user_invalid": "Invalid user.",
                "user_exists": "Another user exists for given email.",
                "user_not_created": "It was not possible to create user.",
                "app_to_update": "Mandatory application update available!",
                "app_no_service": "Service is not available, please retry later. We're sorry for the inconvenience.",
                "error": "Error",
                "debug": "Debug",
                "toast_open": "Opening...",
                "toast_open_fb": "Opening Facebook...",
                "toast_open_yt": "Opening Youtube...",
                "toast_open_g+": "Opening Google+...",
                "toast_open_br": "Opening Browser...",
                "toast_copy": "Link copied to clipboard!",
                "toast_unsubscribed": "Removed subscription!",
                "toast_np_enabled": "Normal notifications: Enabled.",
                "toast_np_disabled": "Normal notifications: Disabled.",
                "share_from_clipboard": "Paste text from clipboard!",
                "share_mail_from": "Notification from",
                "share_mail_notify": "Notification",
                "scroll_cdc": "Scroll list to see all content creators",
                "previous_notifications": "Previous notifications",
                "load_more": "Load more",
                "search_cdc": "Search...",
                "recover_request": "Recovery request",
                "recover_confirm": "Confirm recovery",
                "checkcode": "Control code",
                "newpassword": "New password",
                "confirm_password": "Send password",
                "recover_requested": "Recovery requested",
                "wait_code": "Wait an email with the control code to change the password.",
                "recover_request_error": "Error during request. Please contact the team.",
                "recover_confirmed": "Recovery done",
                "password_changed": "The password has been succesfully changed.",
                "recover_confirm_error": "Error during password change. Please contact the team."
            }
        };

        var currentLocale = null;

        var currentLanguage = null;

        return {
            isLocalized: function () {
                return currentLocale !== null;
            },
            getText: function (key) {
                return currentLocale[key];
            },
            formatDate: function (aUTCDate) {
                aUTCDate = aUTCDate.replace(' ', 'T') + 'Z';
                var date = new Date(aUTCDate);
                //console.log(aUTCDate + " => " + date);
                return $filter('date')(date, 'dd/MM/yyyy - HH:mm');
            },
            getCurrentLanguage: function () {
                return currentLanguage;
            },
            setCurrentLocale: function (locale) {
                if (locale !== null) {
                    var language = locale.substring(0, 2);
                    if (language === "it") {
                        currentLocale = localizedText.it;
                        currentLanguage = "it";
                    } else {
                        currentLocale = localizedText.en;
                        currentLanguage = "en";
                    }
                } else {
                    try {
                        var language = navigator.language.substring(0, 2);
                        if (language === "it") {
                            currentLocale = localizedText.it;
                            currentLanguage = "it";
                        } else {
                            currentLocale = localizedText.en;
                            currentLanguage = "en";
                        }
                    } catch (error) {
                        currentLocale = localizedText.en;
                        currentLanguage = "en";
                    }
                }
            }
        };
    }]);