'use strict';

var sessionService = angular.module('NotibeProject.services.popup', []);

sessionService.factory('Popup', ['$ionicPopup', 'I18n', function ($ionicPopup, I18n) {
        var getText = function (key) {
            var text = I18n.getText(key);
            return (text === undefined) ? key : text;
        };

        return {
            error: function (message) {
                $ionicPopup.alert({
                    title: getText('error'),
                    template: getText(message)
                });
            },
            debug: function (message) {
                $ionicPopup.alert({
                    title: getText('debug'),
                    template: getText(message)
                });
            },
            message: function (title, message) {
                var alertPopup = $ionicPopup.alert({
                    title: getText(title),
                    template: getText(message)
                });
                return alertPopup;
            },
            confirm: function (title, message) {
                var confirmPopup = $ionicPopup.confirm({
                    title: getText(title),
                    template: getText(message)
                });
                return confirmPopup;
            }
        };
    }]);