'use strict';

var sessionService = angular.module('NotibeProject.services.session', []);

sessionService.factory('Session', ['$rootScope', '$ionicLoading', function ($rootScope, $ionicLoading) {
        var versionAndroid = '1.1.2';
        var versionIos = '1.1.0';
        var securityToken = 'd1z00uxKL0dI2eW874Wk4ypWa4e9UaX7';
        //SET FALSE WHEN UPLOADED ON PRODUCTION IOS FOR APNS INSTEAD APNS_SANDBOX
        var isDevelopment = false;
        //TEST URL
        //var baseUrl = 'http://ec2-54-229-152-200.eu-west-1.compute.amazonaws.com:8080';
        //PROD URL
        var baseUrl = 'http://api.notibe.it:14295';
        var servicePath = '/notibe/cxf/rest';
        //session data
        $rootScope.currentUser = {
            //spring rememberme token
            t: null,
            //user data
            id: null,
            firstname: null,
            lastname: null,
            username: null,
            //long term security token
            ltt: null,
            //user roles
            roles: [],
            //cc channels subscribed (dictionary for fast check)
            subscriptionsDictionary: {},
            nameToShow: null
        };
        $rootScope.sessionData = {
            //device info
            device: {
                pushid: null
            },
            //media notifications data structures
            firstNotification: {},
            previousNotifications: [],
            //the dictionary of content creators to show into cdc grid
            contentCreators: {
                search: null,
                page: -1,
                has_next: true,
                list: []
            },
            //the cc's notification stream
            stream: {
                page: -1,
                has_next: true,
                list: []
            },
            //notifications by medianame
            mediaNotifications: {
// THIS IS POPULATED DYNAMICALLY WITH SIMILAR RECORDS
//                "mediaName": {
//                    page: -1,
//                    has_next: true,
//                    list: []
//                }
            }
        };

        return {
            versionAndroid: versionAndroid,
            versionIos: versionIos,
            securityToken: securityToken,
            isDevelopment: isDevelopment,
            baseUrl: baseUrl,
            servicePath: servicePath,
            currentUser: $rootScope.currentUser,
            sessionData: $rootScope.sessionData,
            isIos: function () {
                var isIos = $rootScope.sessionData.device.platform === 'iOS';
                //console.log("Is IOS? " + isIos);
                return isIos;
            },
            startLoading: function () {
                $ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
            },
            stopLoading: function () {
                $ionicLoading.hide();
            },
            userIsLogged: function () {
                return $rootScope.currentUser.id !== null;
            },
            logout: function () {
                //init current user
                $rootScope.currentUser.t = null;
                $rootScope.currentUser.id = null;
                $rootScope.currentUser.firstname = null;
                $rootScope.currentUser.lastname = null;
                $rootScope.currentUser.username = null;
                $rootScope.currentUser.ltt = null;
                $rootScope.currentUser.roles = [];
                $rootScope.currentUser.subscriptionsDictionary = {};
                $rootScope.currentUser.nameToShow = null;
                //init session data
                $rootScope.sessionData.firstNotification = {};
                $rootScope.sessionData.previousNotifications = [];
                $rootScope.sessionData.contentCreators = {
                    search: null,
                    page: -1,
                    has_next: true,
                    list: []
                };
                $rootScope.sessionData.stream = {
                    page: -1,
                    has_next: true,
                    list: []
                };
                $rootScope.sessionData.mediaNotifications = {};
            }
        };
    }]);